package com.lostinsoftware.rest.client;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.http.converter.json.MappingJacksonHttpMessageConverter;
import org.springframework.util.StringUtils;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

import com.lostinsoftware.rest.types.GeoIPJson;
import com.lostinsoftware.rest.types.Response;

public class GeoIPTest {

  @Test
  public void XMLTest(){
    RestTemplate restTemplate = new RestTemplate();
    Response geoIPXml=null;
    try {
      geoIPXml = restTemplate.getForObject(new URI("http://freegeoip.net/xml") , Response.class);
    } catch (RestClientException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (URISyntaxException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
    assertNotNull(geoIPXml);
  }

  @Test
  public void JSonTest(){
    RestTemplate restTemplate = new RestTemplate();
    List<HttpMessageConverter<?>> messageConverters = new ArrayList<HttpMessageConverter<?>>();
    
    // Add the JSon Message converter
    messageConverters.add(new MappingJacksonHttpMessageConverter());    
    GeoIPJson geoIPJson=null;
    try {
      geoIPJson = restTemplate.getForObject(new URI("http://freegeoip.net/json") , GeoIPJson.class);
    } catch (RestClientException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (URISyntaxException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    };
    assertNotNull(geoIPJson);
  }
  
  @Test
  public void CSVTest(){
    RestTemplate restTemplate = new RestTemplate();
    List<HttpMessageConverter<?>> messageConverters = new ArrayList<HttpMessageConverter<?>>();
    
    // Add the String Message converter
    messageConverters.add(new StringHttpMessageConverter());    
    String geoIPcsv=null;
    try {
      geoIPcsv = restTemplate.getForObject(new URI("http://freegeoip.net/csv") , String.class);
    } catch (RestClientException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (URISyntaxException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    };
    assertNotNull(geoIPcsv);
    String[] data = StringUtils.commaDelimitedListToStringArray(geoIPcsv);
    assertTrue(data.length>1);
  }  
}
